//---------------------------------------------------------------------------
// Application: WixStep.nlm. Hand-Held Terminal (HHT) Server for Novell Server
//							and Socket Services. Developed for Wickes.
// Project: WickesRFDeviceNLMSourceEdit - Developed with MS Visual Studio
//					2003 C++ and compiled with Watcom C/C++ and Watcom linker V 11.0
//					using NMAKE.
// --------------------------------------------------------------------------
// Module:App.c - Main loop for processing the script file and STEP packets
//
//	Once an HHT is connected to a socket, packets from it are given to lApp(),
//	one at a time, for processing. lApp() responds to each input packet by reading
//	commands from a scripting or 'macro' text file (WIXSTEP.TXT). As commands are
//	processed, an output packet is built. When a transmit command is reached,
//	the packet is sent to the HHT and lApp() exits back to the socket processor.
//-----------------------------------------------------------------------------
#define _THIS_SOURCE_HAS_THE_DATA_
#include "wixstep.h"

char pcBuffer[BUFFER_SIZE];

/***************************************************************************
Function:	 The Application
Description: This function is called when ever activity is detected on
				 an active socket port.
Passed:		 Current State position
				 Socket number
				 User Number
Return:		 Next State
****************************************************************************/
long lApp(long lCurrentPos, SOCKET sSocket, int sessionNumber)
{
	USER_TYPE *user = &sUser[sessionNumber];
	MENU_OPTIONS *menu = &pcMenuTable[sessionNumber];
	COUNTED_SKUS *count = &pcCount[sessionNumber];
	GAPWALK_SKUS *gap = &pcGapTable[sessionNumber];

	int iReturn;
	int iLength;
	int iLoop = 1;
	long lNewPos;
	char pcReadBuffer[129];
	char pcMask[129];
	char strTemp1[129];
	char strTemp2[129];
	char strTemp3[129];
	int iTemp1;
	int iTemp2;
	int iTemp3;
	int iTemp4;
	int j;												/*	W2.08	*/
	int	iTempInt;										/*	W2.06	*/
	long lTempLong;										/*	W2.06	*/
	int	iNext;										/*	W2.06	*/
	char *pc1;
	char *pc2;
	BOOL	SelectedPic;								/*	W2.08	*/
	int 	iOcc;										/*	W3.03	*/
	BOOL	bMenuCheck;									/*	W3.06	*/
	char 	strTempInput[3];								/*	W3.06	*/

	iLength = recv(sSocket, pcBuffer, sizeof(pcBuffer), 0);
	/* if the MU gracefully shuts down, rc will be zero on the above recv() */
	if( iLength <= 0) { /* DGC */
		vCloseSocket("Close socket, recv", sSocket, iLength);
		user->fLoggedOn = FALSE;
    ProcessLogWriteLn("Exiting Prematurely lApp");
		return(0); /* receive unsuccessful - stop */
	}
	pcBuffer[iLength] = 0;
	fprintf(ProcessLogHandle(),"INP>(%d):%s\n",iLength,pcBuffer);
	ProcessLogFlushBuffer();

	/* move to correct place in file */
	fseek(hCommandFile,lCurrentPos,SEEK_SET);

	switch(pcBuffer[1]) {
		case 'A': /* attention ready (reply to an AT) */
		case 'E': /* error <seq>E<error code> (2 digit) */
		case 'R': /* ready */
			break;
		case 'I': /* receive input:
				 <seq>I<source - K=keyboard,S=scanner,F=Function Key>
				 <length - 3 digit><Data>*/
			if (pcBuffer[2] == 'F') { /* Function Key */
				pcBuffer[6] ^= (char)0x80;
			}
			memcpy(strTemp1,pcBuffer+3,3);
			strTemp1[3]=0;
			iLength = atoi(strTemp1);
			if (iLength > sizeof(sUser->pcLastInput) - 1)
				iLength = sizeof(sUser->pcLastInput) - 1;
			memcpy(user->pcLastInput,&pcBuffer[6],iLength);
			user->pcLastInput[iLength] = 0;
			break;
		default: /* unknown	*/
			break;
	}

	/* now go through command file and construct command into pcBuffer */
	pcBuffer[0] = 0;
	while(iLoop) {
		fgets(pcReadBuffer,128,hCommandFile);
		if(feof(hCommandFile) != 0) {
			/* EOF reached, send logoff (perform by fooling state machine) */
			pcReadBuffer[0] = 'L';
			pcReadBuffer[1] = 0;
		}
		if ((strlen(pcReadBuffer)>1) && (pcReadBuffer[0]!=':') && (pcReadBuffer[0]!='#')) {
			fprintf(ProcessLogHandle(),"CMD>%s",pcReadBuffer);
		}

		ProcessLogFlushBuffer();

		switch(pcReadBuffer[0]) {
			case ':': /* Label	- ignore */
			case '#': /* Comment - ignore */
				break;
			case 'A':
			case 'a': /* Append [FILENAME] command */
				break;
			case 'B':
			case 'b': /* Beep command or Build Menu(W3.06) */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				if(memcmp(strTemp1,"BUILD_MENU",strlen(strTemp1)) == 0) {			  /*W3.06*/

					ProcessLogWriteLn("**BUILD_MENU Start");

					memset(menu->pcAfpn,0,sizeof(menu->pcAfpn));
					memset(menu->pcOption,0,sizeof(menu->pcOption));
					memset(menu->pcOption,' ',sizeof(menu->pcOption)-1);
					user->bScreenTop = FALSE;
					user->bScreenBot = FALSE;

					iOcc=0;		/* Set for first table occurrance*/
					user->iThisLine = iOcc;
					while( ReadAfpCtlTable(sessionNumber) == 1 ) {
						if (atoi(user->pcSecl) < atoi(user->fpSecl)) {

						}	else {
							strncpy_s(menu->pcAfpn+((iOcc)*2), sizeof(menu->pcAfpn)-((iOcc)*2),user->fpNumb,2);
							strncpy_s(menu->pcOption+((iOcc)*20), sizeof(menu->pcOption)-((iOcc)*20),user->fpDesc,20);
							iOcc++;
							fprintf(ProcessLogHandle(),"Menu option %s - %s\n",user->fpNumb,user->fpDesc);
						}
						user->bScreenTop = TRUE;
						user->bScreenBot = FALSE;
						user->iBotLine = iOcc;
						/* Increment AFPN for next Seek */
						sprintf_s(user->pcAfpn, sizeof(user->pcAfpn),"%02d",atoi(user->pcAfpn)+1);
					}
				}
				if(memcmp(strTemp1,"BEEP",strlen(strTemp1)) == 0) {
					sprintf_s(strTemp1, sizeof(strTemp1),"%cB",27);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				}
				break;
			case 'C':
			case 'c': /* Close [FILENAME] command */
				strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
				break;
			case 'D':
			case 'd': /* Display <row> <col> "Text" or [FIELD] command */
				/* get parameters */
				sscanf_s(pcReadBuffer,"%s %d %d %s",strTemp1,sizeof(strTemp1), &iTemp1,&iTemp2,strTemp2, sizeof(strTemp2));
				if (strTemp2[0] != '[') { /* Display a Field surrounded by brackets */
					pc1 = strchr(pcReadBuffer,'"');
					pc2 = strrchr(pcReadBuffer,'"');
					if(pc1 == NULL || pc1 == pc2)
						strTemp2[0] = 0;
					else /* terminate string at second quotation mark */
						*pc2 = 0;
					strcpy_s(strTemp2, sizeof(strTemp2),pc1 + 1);
				/* printf("Display command: %s,%d,%d,%s\n",strTemp1,iTemp1,iTemp2,strTemp2); */
					sprintf_s(strTemp1, sizeof(strTemp1),"%cD%02d%02d%03d%s",27,iTemp1,
					iTemp2,strlen(strTemp2),strTemp2);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				} else { /* Display some text from a Field */
					vGetField(strTemp2, sizeof(strTemp2), sessionNumber);
					if (strlen(strTemp2) > 0) {
						sprintf_s(strTemp1, sizeof(strTemp1),"%cD%02d%02d%03d%s",27,iTemp1,iTemp2,strlen(strTemp2),strTemp2);
						strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
					}
				}
				break;
			case 'E':
			case 'e': /* Erase (Clear screen) command */
				sprintf_s(strTemp1, sizeof(strTemp1),"%cC00",27);
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'F':
			case 'f': /* Field [FIELD] "TEXT" set field command */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				/* Specifically for Label Field updates */
				if(memcmp(strTemp3,"+",strlen(strTemp3)) == 0) {
					vAddField(strTemp2, sessionNumber);
					break;
				}
				pc1 = strchr(pcReadBuffer,'"');
				pc2 = strrchr(pcReadBuffer,'"');
				if(pc1 == NULL || pc1 == pc2)
					strTemp1[0] = 0;
				else /* terminate string at second quotation mark */
					*pc2 = 0;
				strcpy_s(strTemp1, sizeof(strTemp1),pc1 + 1);
				vSetField(strTemp2,strTemp1, sessionNumber);
				break;
			case 'G':
			case 'g': /* Goto [LABEL] command */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				if(iFindLabel(strTemp2) == 0) {
					fprintf(ProcessLogHandle(),"Error Finding Label %s\n",strTemp2);
				}
				break;
			case 'I':
			case 'i': /* Input <row> <col> <size> "Text" or [FIELD] command */
				/* get parameters */
				iTemp4 = 0;
				sscanf_s(pcReadBuffer,"%s %d %d %d %s",strTemp1, sizeof(strTemp1),&iTemp1,&iTemp2,&iTemp3,strTemp2, sizeof(strTemp2));
				if (strTemp2[0] != '[') { /* Display a Field surrounded by brackets */
					pc1 = strchr(pcReadBuffer,'"');
					if(pc1 != NULL) {  /* there is a default string */
						pc2 = strrchr(pcReadBuffer,'"');
						if(pc1 == pc2) {
							strTemp2[0] = 0;
						} else { /* terminate string at second quotation mark */
							*pc2 = 0;
						}
						strcpy_s(strTemp2, sizeof(strTemp2),pc1 + 1);
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%03d%s",27,iTemp1,iTemp2,iTemp3,
							strlen(strTemp2),strTemp2);
					} else { /* Input with no default string */
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d",27,iTemp1,iTemp2,iTemp3);
					}
				} else { /* Input with a Field */
					vGetField(strTemp2, sizeof(strTemp2), sessionNumber);
					sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%03d%s",27,iTemp1,iTemp2,iTemp3,
						strlen(strTemp2),strTemp2);
				}
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'J':
			case 'j': /* Jump TEST [LABEL] command */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp3, sizeof(strTemp3),strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2));
				if (strTemp1[0] != '[') { /* Display a Field surrounded by brackets */
					if (memcmp(user->pcLastInput,strTemp1,strlen(strTemp1)) == 0) {
						fprintf(ProcessLogHandle(),"JUMPing (%s=%s) to %s\n",user->pcLastInput,strTemp1,strTemp2);
						if(iFindLabel(strTemp2) == 0) {
							//fprintf(hLogFile,"Error Finding Label %s\n",strTemp2);
						}
					}
				} else { /* escape keys */
					if ((strTemp1[1] == 'C') || (strTemp1[1] == 'c')) { /* Test for [CR] carrage return */
						if (strlen(user->pcLastInput) == 0) {
							fprintf(ProcessLogHandle(),"JUMPing ([CR]) to %s\n",strTemp2);
							if(iFindLabel(strTemp2) == 0) {
								//fprintf(hLogFile,"Error Finding Label %s\n",strTemp2);
							}
						} else {
							memset(pcMask,' ',strlen(user->pcLastInput));
							if (memcmp(user->pcLastInput,pcMask,strlen(pcMask)) == 0) {
								fprintf(ProcessLogHandle(),"JUMPing (' ') to %s\n",strTemp2);
								if(iFindLabel(strTemp2) == 0) {
									// fprintf(hLogFile,"Error Finding Label %s\n",strTemp2);
								}
							}
						}
					} else if ((strTemp1[1] == 'F') || (strTemp1[1] == 'f')) {
						  if (((UCHAR)(user->pcLastInput[0]) == 193) ||
								 (((UCHAR)(user->pcLastInput[0]) > 175) && ((UCHAR)(user->pcLastInput[0]) < 186))) {  /* Test for [FX] [0-9] function key */
								if ((user->pcLastInput[0] & 0x7F) == strTemp1[2]) {
									fprintf(ProcessLogHandle(),"JUMPing (FKey) to %s\n",strTemp2);
									if(iFindLabel(strTemp2) == 0) {
										//fprintf(hLogFile,"Error Finding Label %s\n",strTemp2);
								}
							}
						}
					}
				}
				break;
			case 'K':
			case 'k': /* KeyCheck noecho command */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				memset(pcMask, 0, sizeof(pcMask));
				memset(pcMask, '?', 1); /* ? = All keys enabled */
				if(memcmp(strTemp2,"SACODES",7) == 0) {
					sprintf_s(strTemp1, sizeof(strTemp1),"%cN0820001@%c%c%03d?",27,0x52,0x41,strlen(pcMask),pcMask);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
					//fprintf(hLogFile,"KeyCheck : %s \n",strTemp1);
					break;
				}
				sprintf_s(strTemp1, sizeof(strTemp1),"%cN0820001@%c%c",27,0x52,0x40);
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'L':
			case 'l': /* logout command */
				sprintf_s(strTemp1, sizeof(strTemp1),"%cL\0",27);
				memset(pcBuffer,0,sizeof(pcBuffer));
				strcpy_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				iLoop = 0;
				user->fLoggedOn = FALSE;
				break;
			case 'M':
			case 'm': /* Message "Text" */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				pc1 = strchr(pcReadBuffer,'"');
				pc2 = strrchr(pcReadBuffer,'"');
				if(pc1 == NULL || pc1 == pc2)
					strTemp2[0] = 0;
				else /* terminate string at second quotation mark */
					*pc2 = 0;
				strcpy_s(strTemp2, sizeof(strTemp2),pc1 + 1);
			/* printf("Message command: %s,%d,%d,%s\n",strTemp1,strTemp2); */
				sprintf_s(strTemp1, sizeof(strTemp1),"%cD%02d%02d%03d%s", 27, '1', '1',
						  strlen(strTemp2), strTemp2);
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				sprintf_s(strTemp1, sizeof(strTemp1),"%cN0820001@%c%c",27,0x52,0x40);
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'N':
			case 'n': /* Numeric <row> <col> <size> "Text" or [FIELD] input command */
				/* get parameters */
				iTemp4 = 0;
				memset(strTemp2,0,sizeof(strTemp2));						/*W3.04*/
				sscanf_s(pcReadBuffer,"%s %d %d %d %s",strTemp1, sizeof(strTemp1),&iTemp1,&iTemp2,&iTemp3,strTemp2, sizeof(strTemp2));
				//fprintf(hLogFile,"%s %d %d %d %s\n",strTemp1,&iTemp1,&iTemp2,&iTemp3,strTemp2);
				if(memcmp(strTemp2,"PASSWORD",8) == 0) {				/*W3.02*/
					memset(pcMask, 0, sizeof(pcMask));
					memset(pcMask, '9', iTemp3); /* 9 = Numeric */
					sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d@%c%c%03d%s",27,iTemp1,iTemp2,iTemp3,0x50,0x61,iTemp3,pcMask);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
					break;
				}
				if (strTemp2[0] != '[') { /* Display a Field surrounded by brackets */
					pc1 = strchr(pcReadBuffer,'"');
					if(pc1 != NULL) { /* there is a default string */
						pc2 = strrchr(pcReadBuffer,'"');
						if(pc1 == pc2)
							strTemp2[0] = 0;
						else /* terminate string at second quotation mark */
							*pc2 = 0;
						strcpy_s(strTemp2, sizeof(strTemp2),pc1 + 1);
						memset(pcMask, 0, sizeof(pcMask));
						memset(pcMask, '9', iTemp3); /* 9 = Numeric */
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%c%c%c%03d%s%03d%s",27,iTemp1,iTemp2,iTemp3,
								  0x40,0x50,0x49,iTemp3,pcMask,strlen(strTemp2),strTemp2);
					} else { /* Input with no default string */
						memset(pcMask, 0, sizeof(pcMask));
						memset(pcMask, '#', iTemp3); /* # = Numeric (+/-) */
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%c%c%c%03d%s",27,iTemp1,iTemp2,iTemp3,
								  0x40,0x50,0x41,iTemp3,pcMask);
					}
				} else {/* Input with a Field */
					if(memcmp(strTemp2,"[QREQ]",8) == 0) {			/*W3.04*/
						vGetField(strTemp2, sizeof(strTemp2), sessionNumber);
						memset(pcMask, 0, sizeof(pcMask));
						memset(pcMask, '#', iTemp3); /* 9 = Numeric */
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%c%c%c%03d%s%03d%s",27,iTemp1,iTemp2,iTemp3,
							  0x40,0x50,0x49,iTemp3,pcMask,strlen(strTemp2),strTemp2);
					}	else {
						vGetField(strTemp2, sizeof(strTemp2), sessionNumber);
						memset(pcMask, 0, sizeof(pcMask));
						memset(pcMask, '9', iTemp3); /* 9 = Numeric */
						sprintf_s(strTemp1, sizeof(strTemp1),"%cI%02d%02d%03d%c%c%c%03d%s%03d%s",27,iTemp1,iTemp2,iTemp3,
								  0x40,0x50,0x49,iTemp3,pcMask,strlen(strTemp2),strTemp2);
					}
				}
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'O':
			case 'o': /* Open [FILENAME] command */
				strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
				break;
			case 'P':
			case 'p': /* Read Previous [FILENAME] command or PUT table record (insert) */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				if(memcmp(strTemp2,"[SACODE]",strlen(strTemp2)) == 0){
					if (!user->bScreenTop) {
						iNext = 2;
					  while( iNext == 2 )  {
							if ((iNext = iPriorSaCodeDatabase(sessionNumber)) == 1) {
								user->bScreenBot = FALSE;
								DBstrncpy(user->pcSaStart,user->pcSaNumb,sizeof(user->pcSaStart));
								user->iEnquiryLine+=-1;
							}
						}
						if(user->iEnquiryLine == 1) {
							 user->bScreenTop = TRUE ;
					 	}
			   	}
				}
				if(memcmp(strTemp2,"[SYSCOD]",strlen(strTemp2)) == 0){
					if (!user->bScreenTop) {
						iNext = 2;
					  while( iNext == 2 ) {
							if ((iNext = iPriorSysCodDatabase(sessionNumber)) == 1) {
								user->bScreenBot = FALSE ;
								strncpy_s(user->pcSyStart, sizeof(user->pcSyStart),user->syCode,	sizeof(user->syCode));
								user->iEnquiryLine+=-1;
							}
						}
						if(user->iEnquiryLine == 1) {
							user->bScreenTop = TRUE ;
						}
					}
				}
				if(memcmp(strTemp2,"[STKADJ]",strlen(strTemp2)) == 0)	/*W2.06*/
					bInsertStkAdjDatabase(sessionNumber);						/*W2.06*/
				if(memcmp(strTemp2,"[STKL91]",strlen(strTemp2)) == 0){/*W2.07*/
					iNext = 1;										/*W2.07*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");				/*W2.07*/
					if ((iNext = iPriorStkLogDatabase(sessionNumber)) == 1)	/*W2.07*/
						iInsertStkLogAdjust91(sessionNumber);					/*W2.07*/
					else											/*W2.07*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");			/*W2.07*/
				}													/*W2.07*/
				if(memcmp(strTemp2,"[STKLOG]",strlen(strTemp2)) == 0)	/*W3.02*/
					iInsertStkLogDatabase(sessionNumber, atoi(strTemp3) );		/*W3.06*/
				if(memcmp(strTemp2,"[ACTLOG]",strlen(strTemp2)) == 0)
					PutInsertActivityLog( sessionNumber);
				if(memcmp(strTemp2,"[TMPFIL]",strlen(strTemp2)) == 0)	/*W3.03*/
					InsertTmpfileLabels(sessionNumber);		/*W3.03*/
				if(memcmp(strTemp2,"[GAPWALK]",strlen(strTemp2)) == 0)/*W3.03*/
					iInsertGapWalkTmpfilRecord(sessionNumber);						/*W3.03*/
				break;
			case 'Q':
			case 'q':	// Query a field
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				/* Query the DataBase Date */
				if(memcmp(strTemp2,"[DDATE]",strlen(strTemp2)) == 0) {
					fprintf(ProcessLogHandle(),"Query ddate - nothing to do??...\n");
					//fprintf(hLogFile,"?? - [DDATE] Converting date ??\n");
					//fprintf(hLogFile,"Converting date\n");
					//vGetDataBaseDate();
				}
				/* Query the Day Number    */
				if (memcmp(strTemp2,"[DAYNUM]",strlen(strTemp2)) == 0) {
				//	vLastStkLogDatabase(i);				// read last stklog to populate sUser
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
				}
				if(memcmp(strTemp2,"[SCR-POS]",strlen(strTemp2)) == 0){ 	/*W2.06*/
					strcpy_s(strTemp1, sizeof(strTemp1),"DISPLAY");							/*W2.06*/
					strcpy_s(strTemp2, sizeof(strTemp2),"8 1");								/*W2.06*/
					if (user->bScreenTop) {							/*W2.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");				/*W2.06*/
						break;											/*W2.06*/
					}													/*W2.06*/
					if (user->bScreenBot) { 							/*W2.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");				/*W2.06*/
						break;											/*W2.06*/
					}													/*W2.06*/
					if(user->iEnquiryLine == 1) {					/*W3.06*/
						if(user->iReasonLine < 6) {					/*W3.06*/
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"3");			/*W3.06*/
							break;										/*W3.06*/
						}												/*W3.06*/
					}													/*W3.06*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"2");					/*W2.06*/
					break;												/*W2.06*/
				}
				if(memcmp(strTemp2,"[MSC-POS]",strlen(strTemp2)) == 0){ 	/*W3.06*/
					if (user->iBotLine < 6 ) {						/*W3.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"3");				/*W3.06*/
						break;											/*W3.06*/
					}													/*W3.06*/
					if ((user->iThisLine + 5) == user->iBotLine ) /*W3.06*/
						user->bScreenBot	= TRUE;						/*W3.06*/
					if (user->iThisLine == 0 )				 		/*W3.06*/
						user->bScreenTop	= TRUE;						/*W3.06*/
					if (user->bScreenTop) {							/*W3.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");				/*W3.06*/
						break;
					}
					if (user->bScreenBot) { 							/*W3.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");				/*W3.06*/
						break;
					}
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"2");					/*W3.06*/
					break;
				}
				if(memcmp(strTemp2,"[NXT-CNT]",strlen(strTemp2)) == 0){
					/* Set up SKU to Be checked      */
					SelectedPic = atoi(strTemp3);
					if (SelectedPic)	{
						strcpy_s(user->hdSkun, sizeof(user->hdSkun),user->pcSkun);
					}
					/* Check if SKU is being Counted */
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					for (j=0;j < MAX_SOCKETS;j++) {
						if (memcmp(user->hdSkun,pcCount[j].pcSkun,sizeof(pcCount[j].pcSkun)) == 0)	{
							fprintf(ProcessLogHandle(),"SKU %s is being counted by %d\n",user->hdSkun,j);
							if (!SelectedPic)	{
								sprintf_s(user->pcSkun, sizeof(user->pcSkun),"%6ld",atoi(user->hdSkun) + 1);
								fprintf(ProcessLogHandle(),"Read Next SKU ->%s\n",user->pcSkun);
							}
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
							break;
						}
					}
				}
				if(memcmp(strTemp2,"PASSWORD",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					if(memcmp(user->pcPass,user->spPass,sizeof(user->pcPass)) == 0) {
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					}
				}
				if(memcmp(strTemp2,"[SECL]",strlen(strTemp2)) == 0) {		/*W3.02*/
					iOcc = atoi(strTemp3)-1;								/*W3.03*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");					/*W3.02*/
					if (atoi(strTemp3) == 1) {							/*W3.02*/
						memset(user->pcMenuOpts,0,sizeof(user->pcMenuOpts));/*W3.02*/
						memset(user->pcMenuOpts,'N',sizeof(user->pcMenuOpts)-1);/*W3.02*/
					}
					//fprintf(hLogFile,"QUERY SECL : pcSecl is %d and fpSecl is %d\n",atoi(user->pcSecl),atoi(user->fpSecl));		/*W3.02*/
					if(atoi(user->pcSecl) < atoi(user->fpSecl))
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					else
						user->pcMenuOpts[atoi(strTemp3)-1] = 'Y';
				//memset(user->pcMend+iOcc,0,21);
				//strncpy(user->pcMend+iOcc,user->fpDesc,20);
				}														/*W3.02*/
				if(memcmp(strTemp2,"[SSEC]",strlen(strTemp2)) == 0) {
					iOcc = atoi(strTemp3)-11;
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if (atoi(strTemp3) == 11) {
						memset(user->pcSubOpts,0,sizeof(user->pcSubMenu));
						memset(user->pcSubOpts,'N',sizeof(user->pcSubMenu)-1);
					}
					if(atoi(user->pcSecl) < atoi(user->fpSecl))
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					else
						user->pcSubOpts[atoi(strTemp3)-11] = 'Y';
				}
				/*
				if(memcmp(strTemp2,"[IAFG]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					if (user->fpIafg[0] == 32)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
				}
				*/
				if(memcmp(strTemp2,"[MENU_OPTS]",strlen(strTemp2)) == 0){	/*W3.02*/
					if(user->pcMenuOpts[atoi(user->pcLastInput)-1] == 'N')
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"X");
				}
				if(memcmp(strTemp2,"[SMENU_OPTS]",strlen(strTemp2)) == 0){/*W3.04*/
					if(user->pcSubOpts[atoi(user->pcLastInput)-1] == 'N')
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"X");
				}
				if(memcmp(strTemp2,"[AGSL]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");

					fprintf(ProcessLogHandle(),"**Comparing [AGSL]  %s  to  %s\n",user->pcSecl,user->gcDscl);

					if(atoi(user->pcSecl) < atoi(user->gcDscl))
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				/* Query Price Change */
				if(memcmp(strTemp2,"[PRCCHG]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if (!user->pcDoingPriceChange)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				/* Query Aapc */
				if(memcmp(strTemp2,"[AAPC]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(user->imAapc[0] != '0')												// Can't update SKUs that are auto price change
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				/* Query If STKMAS label Qty is to be updated */
				if(memcmp(strTemp2,"[IM:LABELS]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if ((atoi(user->pcSlab) == 0) && (atoi(user->pcMlab) == 0) && (atoi(user->pcLlab) == 0)) {
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					}
				}
				/* Query If TMPFIL label Qty is to be updated */
				if(memcmp(strTemp2,"[TF:LABELS]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					if((atoi(user->pcSlab) > 0)||
					   (atoi(user->pcMlab) > 0)||
					   (atoi(user->pcLlab) > 0))
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
				}
				/* Query The Label for repositioning */
				if(memcmp(strTemp2,"[POSN_LABEL]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					if(memcmp(user->pcThisLabel,"SLAB",4) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcThisLabel,"MLAB",4) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"2");
					if(memcmp(user->pcThisLabel,"LLAB",4) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"3");
				}
				// Validate the Small Label Entry   W3.03
				if(memcmp(strTemp2,"[SLAB]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					if (user->pcDoingPriceChange) {
						if (user->ipLabs){
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "2");
							break;
						}
					}
					if ((atoi(user->pcSlab) > 9)||	(atoi(user->pcSlab) < -9)){
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
					}
				}
				// Validate the Medium Label Entry 	W3.03
				if(memcmp(strTemp2,"[MLAB]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					if (user->pcDoingPriceChange){
						if (user->ipLabm)	{
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "2");
							break;
						}
					}
					if ((atoi(user->pcMlab) > 9)||	(atoi(user->pcMlab) < -9))	{
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
					}
				}
				// Validate the Large  Label Entry 	W3.03
				if(memcmp(strTemp2,"[LLAB]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					if (user->pcDoingPriceChange){
						if (user->ipLabl)	{
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "2");
							break;
						}
					}
					if ((atoi(user->pcLlab) > 9)||	(atoi(user->pcLlab) < -9))	{
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
					}
				}
				/* Query the EQPU value for blanks 	W3.03*/
				if(memcmp(strTemp2,"[EQPU]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					if(memcmp(user->imEqpu,"    ",4) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
				}
				/* Query WalkAbout Selected */
				if(memcmp(strTemp2,"[WALKABOUT]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcWalkAbout,"NO",2) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				// Query the SKUs Status
				if(memcmp(strTemp2,"[IM:STATUS]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					if(memcmp(user->pcImStatus,"    ",4) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
				}
				// Query Any Previous Quantity requested?
				if(memcmp(strTemp2,"[QTY-REQ]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
					user->bNewGapSect = FALSE;
					if (SeekGapWalkTmpfilRecord(sessionNumber) == 0) {						/* if No previous Gap Walk Record found*/
						user->bNewGapSect = TRUE;
						sprintf_s(user->pcReqQty, sizeof(user->pcReqQty),"%6ld",atol(user->imOnha)+atol(user->imMdnq));
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
					}
				}
				/* Query Ist SKU in WalkAbout */
				if(memcmp(strTemp2,"[FIRSTWALK]",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcFirstWalk,"NO",2) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				if(memcmp(strTemp2,"[GAP_SKU]",strlen(strTemp2)) == 0){
					/* Check if SKU is being Counted */
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					for (j=0;j < MAX_SOCKETS;j++) {
						if (memcmp(user->pcSkun,pcGapTable[j].pcSkun,sizeof(user->pcSkun)) == 0)	{
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
							break;
						}
					}
				}
				if(memcmp(strTemp2,"MENU_LINES",strlen(strTemp2)) == 0){
					memset(user->pcMenuLine1,0,sizeof(user->pcMenuLine1));
					memset(user->pcMenuLine1,' ',sizeof(user->pcMenuLine1)-1);
					memset(user->pcMenuLine2,0,sizeof(user->pcMenuLine2));
					memset(user->pcMenuLine2,' ',sizeof(user->pcMenuLine2)-1);
					memset(user->pcMenuLine3,0,sizeof(user->pcMenuLine3));
					memset(user->pcMenuLine3,' ',sizeof(user->pcMenuLine3)-1);
					memset(user->pcMenuLine4,0,sizeof(user->pcMenuLine4));
					memset(user->pcMenuLine4,' ',sizeof(user->pcMenuLine4)-1);
					memset(user->pcMenuLine5,0,sizeof(user->pcMenuLine5));
					memset(user->pcMenuLine5,' ',sizeof(user->pcMenuLine5)-1);

					user->bScreenTop = FALSE ;
					user->bScreenBot = FALSE ;
					if (user->iThisLine == 0)
						user->bScreenTop = TRUE ;
					if (user->iThisLine == user->iBotLine )
						user->bScreenBot = TRUE ;
					j = ( user->iThisLine * 2 );
					if(strlen(menu->pcAfpn+j) > 0 )
						strncpy_s(user->pcMenuLine1, sizeof(user->pcMenuLine1),menu->pcAfpn+j+1,1);
						strcat_s(user->pcMenuLine1, sizeof(user->pcMenuLine1) - 1, " ");
					if(strlen(menu->pcAfpn+j+2) > 0 )
						strncpy_s(user->pcMenuLine2, sizeof(user->pcMenuLine2),menu->pcAfpn+j+3,1);
						strcat_s(user->pcMenuLine2, sizeof(user->pcMenuLine2) - 1, " ");
					if(strlen(menu->pcAfpn+j+4) > 0 )
						strncpy_s(user->pcMenuLine3, sizeof(user->pcMenuLine3),menu->pcAfpn+j+5,1);
						strcat_s(user->pcMenuLine3, sizeof(user->pcMenuLine3) - 1, " ");
					if(strlen(menu->pcAfpn+j+6) > 0 )
						strncpy_s(user->pcMenuLine4, sizeof(user->pcMenuLine4),menu->pcAfpn+j+7,1);
						strcat_s(user->pcMenuLine4, sizeof(user->pcMenuLine4) - 1, " ");
					if(strlen(menu->pcAfpn+j+8) > 0 )
						strncpy_s(user->pcMenuLine5, sizeof(user->pcMenuLine5),menu->pcAfpn+j+9,1);
						strcat_s(user->pcMenuLine5, sizeof(user->pcMenuLine5) - 1, " ");
					j = ( user->iThisLine * 20 );
					strncpy_s(user->pcMenuLine1+2, sizeof(user->pcMenuLine1)-2,menu->pcOption+j,17);
					strncpy_s(user->pcMenuLine2+2, sizeof(user->pcMenuLine2)-2,menu->pcOption+j+20,17);
					strncpy_s(user->pcMenuLine3+2, sizeof(user->pcMenuLine3)-2,menu->pcOption+j+40,17);
					strncpy_s(user->pcMenuLine4+2, sizeof(user->pcMenuLine4)-2,menu->pcOption+j+60,17);
					strncpy_s(user->pcMenuLine5+2, sizeof(user->pcMenuLine5)-2,menu->pcOption+j+80,17);
				}
				if(memcmp(strTemp2,"[CHK_MENU]",strlen(strTemp2)) == 0){
					bMenuCheck = FALSE;
					if(strlen(user->pcLastInput) == 1) {
						sprintf_s(strTempInput, sizeof(strTempInput),"0%s",user->pcLastInput);
					}
					else {
						sprintf_s(strTempInput, sizeof(strTempInput),"%s",user->pcLastInput);
					}
					for (j=0;j<(int)strlen(menu->pcAfpn);j=j+2) {
						if (memcmp(menu->pcAfpn+j,strTempInput,2) == 0)
							bMenuCheck = TRUE;
					}
					if (!bMenuCheck)
						 strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"X");
					else /* reset input */
						 strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),strTempInput);
				}
				/* Query PIC */
				if(memcmp(strTemp2,"[PIC]",strlen(strTemp2)) == 0) { /*W3.06*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcPIC,"NO",2) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				/* Query Shop Floor   */
				if(memcmp(strTemp2,"[SHOPFLOOR]",strlen(strTemp2)) == 0) { /*W3.06*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcShopFloor,"NO",2) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
				}
				/* Query Label Check Selected */
				if(memcmp(strTemp2,"[LABEL_CHK]",strlen(strTemp2)) == 0) {	/*W3.03*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");					/*W3.03*/
					if(memcmp(user->pcLabelCheck,"NO",2) == 0)		/*W3.03*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");				/*W3.03*/
				}
				/* Query Price Change Option */
				if(memcmp(strTemp2,"[PC_OPT]",strlen(strTemp2)) == 0) {	/*W3.06*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");					/*W3.06*/
					if(memcmp(user->pcPcOption,"NO",2) == 0)			/*W3.06*/
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");				/*W3.06*/
						//fprintf(hLogFile,"Query PC_OPT is %s\n",user->pcPcOption);
				}
				/* Query PIC SKU NOF*/
				if(memcmp(strTemp2,"[PIC_NOF]",strlen(strTemp2)) == 0) { /*W3.07*/
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					if(memcmp(user->pcPicSkuNof,"NO",2) == 0)
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					//fprintf(hLogFile,"Query:PicSkuNof is %s\n",user->pcPicSkuNof);
				}
				break;
			case 'R':
			case 'r': /* Read [FILENAME] command */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				//if(memcmp(strTemp2,"[STKMAS]",strlen(strTemp2)) == 0)
				//	iReadStkMasDatabase(sessionNumber);
				//if(memcmp(strTemp2,"[EANMAS]",strlen(strTemp2)) == 0)
				//	iReadEanMasDatabase(sessionNumber);
				if(memcmp(strTemp2,"[HHTHDR]",strlen(strTemp2)) == 0)
					ReadNextHhtHdrRecord(sessionNumber);
				if(memcmp(strTemp2,"[HHTDET]",strlen(strTemp2)) == 0)
					ReadNextHhtDetRecord(sessionNumber);
				//if(memcmp(strTemp2,"[EOFLOG]",strlen(strTemp2)) == 0)
				//	vLastStkLogDatabase(sessionNumber);
				if(memcmp(strTemp2,"[STKLOG]",strlen(strTemp2)) == 0)
					iReadStkLogDatabase(sessionNumber);
				//if(memcmp(strTemp2,"[SYSDAT]",strlen(strTemp2)) == 0)
				//	iReadSysDatDatabase(sessionNumber);
				if(memcmp(strTemp2,"[PRCCHG]",strlen(strTemp2)) == 0)
					iGetNextPrcChgDatabase(sessionNumber);
				// Marldown/writeoff reason codes
				if(memcmp(strTemp2,"[SACODE]",strlen(strTemp2)) == 0){
					if (atoi(strTemp3) == 1 ) {
						iNext = 2;
					  while((iNext == 2)) {
			    		iNext = iGetNextSaCodeDatabase(sessionNumber);
						}
						if (iNext == 1) {
							user->bScreenTop = FALSE ;
							DBstrncpy(user->pcSaStart,user->pcSaNumb,sizeof(user->pcSaStart));
			        user->iEnquiryLine++;
						}
						if (iNext == 3) {
							user->bScreenBot = TRUE;
  					}
					}
					else {
						iNext = 2;
						while((iNext != 0) && (user->iReasonLine < 6)){
						//fprintf(hLogFile,"Read SACODE via Option !1\n");
		    			if ((iNext = iGetNextSaCodeDatabase(sessionNumber)) == 1) {
								if (atoi(user->pcSaStart) == 1 )
									DBstrncpy(user->pcSaStart,user->pcSaNumb,sizeof(user->pcSaStart));
	        			vSetReasonLine( user->iReasonLine, sessionNumber);
								user->iReasonLine++;
       			  }
					  }
						if(user->iEnquiryLine == 1 ) {
							if(user->iReasonLine < 6 ) {
								user->bScreenBot = FALSE;
								user->bScreenTop = FALSE;
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"3");
								break;
							}
						}
						if (iNext == 0)
							user->bScreenBot = TRUE;
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");				/*W2.06*/
					}
				}
				// Label reason codes
				if (memcmp(strTemp2,"[SYSCOD]",strlen(strTemp2)) == 0){
					if (atoi(strTemp3)==1) {
						iNext=2;
					  while(iNext==2) {	// while read but not found
			    		iNext=iGetNextSysCodDatabase(sessionNumber);
						}
						if (iNext==1) {		// If found
							user->bScreenTop = FALSE;
							strncpy_s(user->pcSyStart, sizeof(user->pcSyStart),user->syCode,sizeof(user->syCode));
							user->iEnquiryLine++;
						}
						if (iNext==3) {		// Not found - EOF
							user->bScreenBot = TRUE ;
  					}
					}	else {
						//printf("**READ [SYSCOD] %s, %s, %s\n",user->pcLrType,user->pcLrAttr,user->pcLabelCheck);
						iNext = 1;
						while((iNext == 1) && (user->iReasonLine < 6)){	// Not EOF and screen not full
		    			if ((iNext = iGetNextSysCodDatabase(sessionNumber)) == 1) {		// Found pcLrType & pcLrAttr
								//if (atoi(user->syCode) == 1 ) {							// code 1?
									strncpy_s(user->pcSyStart, sizeof(user->pcSyStart),user->syCode,sizeof(user->syCode));
								//}
	        			vSetReasonLine( user->iReasonLine, sessionNumber);
								user->iReasonLine++;
       			  }
					  }
						if(user->iEnquiryLine == 1 ) {
							if(user->iReasonLine < 6 ) {
								user->bScreenBot = FALSE;
								user->bScreenTop = FALSE;
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"3");
								break;
							}
						}
						if (iNext == 0)
							user->bScreenBot = TRUE;
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
					}
				}
				break;
			case 'S':
			case 's': /* Seek [FILENAME] command */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				if(memcmp(strTemp2,"[STKMAS]",strlen(strTemp2)) == 0)
					iSeekStkMasDatabase(sessionNumber , atoi(strTemp3) );
				if(memcmp(strTemp2,"[EANMAS]",strlen(strTemp2)) == 0)
					iSeekEanMasDatabase(sessionNumber);
				if(memcmp(strTemp2,"[HHTDET]",strlen(strTemp2)) == 0) {
					iSeekHhtDetDatabase(sessionNumber , atoi(strTemp3) );
					break;
				}
				if(memcmp(strTemp2,"[HHTHDR]",strlen(strTemp2)) == 0)
					SeekLastHhtHdrDatabase(sessionNumber);
				if(memcmp(strTemp2,"[STKLOG]",strlen(strTemp2)) == 0) {
					 sprintf_s(user->pcSold, sizeof(user->pcSold), "%6ld",GetStkLogSoldToday(user->pcSkun));
/*
					// Count the sold today for a SKUN/DAYN
				  sprintf_s(user, sizeof(user)->pcSold, "%6ld",0);
					if (iSeekStkLogDatabase(0,i)==1) {
						while(iScanStkLogDatabase((atol(user->pcSold)),sessionNumber)==1)
							{}
					}
	*/
				}
				if (memcmp(strTemp2,"[SACODE]",strlen(strTemp2)) == 0)	{
			    if (atoi(strTemp3) == 1) {
				   	iNext = iSeekSaCodeDatabase(sessionNumber, atoi(strTemp3) );
						if (strncmp(user->pcSaNumb,user->pcSaKey,2)!=0) {
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "4");
							break;
						}
						if (iNext != 1) {
							strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "4");
							break;
						}
						if ((user->pcSaImdn) && (user->pcSaIwtf)) {
						  strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "3");
							break;
						}
					}	else {
						user->iReasonLine = 1;
						vInitReasonDescs(sessionNumber);
	    	    if((iSeekSaCodeDatabase(sessionNumber, atoi(strTemp3) )) == 1) {
							if (atoi(user->pcSaStart) == 0 )
								DBstrncpy(user->pcSaStart,user->pcSaNumb,sizeof(user->pcSaStart));
	        	  vSetReasonLine( user->iReasonLine, sessionNumber);
			        user->iReasonLine++;
						}
					}
				}
				if(memcmp(strTemp2,"[STKADJ]",strlen(strTemp2)) == 0) {
					user->bAdjExists = FALSE ;
					iTempInt = 0 ;
				  sprintf_s(user->pcLastSeqn, sizeof(user->pcLastSeqn),"%d",iTempInt);
					iNext =	iSeekStkAdjDatabase(sessionNumber);
					while (iNext == 1)
						iNext  = iGetNextStkAdjDatabase(sessionNumber);
				}
				if(memcmp(strTemp2,"[SYSPAS]",strlen(strTemp2)) == 0)
					ReadSysPasTable(sessionNumber);
				if(memcmp(strTemp2,"[AFGCTL]",strlen(strTemp2)) == 0)
					ReadAfgCtlTable(sessionNumber);
				if(memcmp(strTemp2,"[AFPCTL]",strlen(strTemp2)) == 0)
					ReadAfpCtlTable(sessionNumber);
				if(memcmp(strTemp2,"[AFDCTL]",strlen(strTemp2)) == 0)
					ReadAfdCtlTable(sessionNumber);
				if(memcmp(strTemp2,"[PRCCHG]",strlen(strTemp2)) == 0)
					iSeekPrcChgDatabase(sessionNumber);
				if(memcmp(strTemp2,"[SYSCOD]",strlen(strTemp2)) == 0){
					/* Seek for Last Input(1) or Price Change Code (2)*/
					//printf("**SEEK [SYSCOD] %s, %s, %s, %s\n",strTemp3,user->pcLrType,user->pcLrAttr,user->pcLabelCheck);
			    if(atoi(strTemp3) != 2) {
				    iSeekSysCodDatabase(sessionNumber, atoi(strTemp3) );
						break;
					}	else {
						/* First SysCod Record */
						user->iReasonLine=1;
						vInitReasonDescs(sessionNumber) ;
	    	    if((iSeekSysCodDatabase(sessionNumber,atoi(strTemp3) )) == 1) {
							if (atoi(user->pcSyStart) == 0 )
								strncpy_s(user->pcSyStart, sizeof(user->pcSyStart),user->syCode,sizeof(user->syCode));
	        	  vSetReasonLine(user->iReasonLine, sessionNumber);
			        user->iReasonLine++;
						}
					}
				}
				break;
			case 'T':
			case 't': /* Transmit send to terminal command */
				iLoop = 0;
				break;
			case 'U':
			case 'u': /* Update or UnLock(W3.05)[FILENAME] command */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp3),strTemp3, sizeof(strTemp3));
				if(memcmp(strTemp1,"UNLOCK",strlen(strTemp1)) == 0) {
					if(memcmp(strTemp2,"[STKMAS]",strlen(strTemp2)) == 0)
						iUnLockStkMasDatabase(sessionNumber);
				}
				if(memcmp(strTemp1,"UPDATE",strlen(strTemp1)) == 0) {
					if(memcmp(strTemp2,"[STKMAS]",strlen(strTemp2)) == 0)
						iUpdateStkMasDatabase(sessionNumber, atoi(strTemp3) );
					if(memcmp(strTemp2,"[HHTHDR]",strlen(strTemp2)) == 0)
						iUpdateHhtHdrDatabase(sessionNumber);
					if(memcmp(strTemp2,"[HHTDET]",strlen(strTemp2)) == 0)
						iUpdateHhtDetDatabase(sessionNumber);
					if(memcmp(strTemp2,"[PRCCHG]",strlen(strTemp2)) == 0)
						iUpdatePrcChgDatabase(sessionNumber);
					if(memcmp(strTemp2,"[TMPFIL]",strlen(strTemp2)) == 0)
						UpdateTmpfilLabelTotals(sessionNumber);
					if(memcmp(strTemp2,"[ACTLOG]",strlen(strTemp2)) == 0)
						iUpdateActLogDatabase(sessionNumber);
					if(memcmp(strTemp2,"[GAPWALK]",strlen(strTemp2)) == 0)
						UpdateGapWalkTmpfilRecord(sessionNumber);
				}
				break;
			case 'V':
			case 'v': /* Video Normal or Reverse command */
					sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				if ((strTemp2[0] == 'R') || (strTemp2[0] == 'r'))
					sprintf_s(strTemp1, sizeof(strTemp1),"%cEVRV1",27);
				else /* Turn reverse video off */
					sprintf_s(strTemp1, sizeof(strTemp1),"%cEVRV0",27);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'W':
			case 'w': /* Write [FIELD] command */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				vSetField(strTemp2,user->pcLastInput, sessionNumber);
				break;
			case 'X':
			case 'x': /* Xtension user defined function */
				sscanf_s(pcReadBuffer,"%s %s %s",strTemp1, sizeof(strTemp1),strTemp2, sizeof(strTemp2),strTemp3, sizeof(strTemp3));
				/* if any commands have been added to the command line */
				/* they should now be executed */
				if(memcmp(strTemp2,"TOGGLE_SET",strlen(strTemp2)) == 0) {
					user->iToggle=user->iToggle+1;
					if (user->iToggle == 4) {
						user->iToggle = 0;
					}
					sprintf_s(user->pcLastInput, sizeof(user->pcLastInput), "%d", user->iToggle);
				}
				if (memcmp(strTemp2,"TOGGLE_READ",strlen(strTemp2)) == 0)
					sprintf_s(user->pcLastInput, sizeof(user->pcLastInput),"%d",user->iToggle);
				if (memcmp(strTemp2,"GOTO_READ",strlen(strTemp2)) == 0)
					sprintf_s(user->pcLastInput, sizeof(user->pcLastInput),"%d",user->iGoto);
				if (memcmp(strTemp2,"FLAG_READ",strlen(strTemp2)) == 0)
					sprintf_s(user->pcLastInput, sizeof(user->pcLastInput),"%d",user->iFlag);
				if (memcmp(strTemp2,"SAVE_READ",strlen(strTemp2)) == 0)
					sprintf_s(user->pcLastInput, sizeof(user->pcLastInput),"%s",user->pcSave);
				if (memcmp(strTemp2,"HHT_HIGH",strlen(strTemp2)) == 0)
					vTestHighField(sessionNumber);
				if (memcmp(strTemp2,"HHT_UPDATE",strlen(strTemp2)) == 0)		// Adds counts to det fields
					vUpdateCountField(sessionNumber);
				//if (memcmp(strTemp2,"HHT_HEADER",strlen(strTemp2)) == 0)		// Not used
				//		sprintf_s(user->pcDone, "%6ld",atol(user->pcDone)+1);
				if (memcmp(strTemp2,"VAL_SIGN",strlen(strTemp2)) == 0) {
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"0");
					lTempLong = atol(user->pcAdjQty);
					if(memcmp(user->pcSaSign,"S",1) == 0) break;
					if((memcmp(user->pcSaSign,"+",1) == 0) && (lTempLong > 0)) break ;
					if((memcmp(user->pcSaSign,"-",1) == 0) && (lTempLong < 0)) break ;
					strcpy_s(user->pcLastInput, sizeof(user->pcLastInput),"1");
				}
				if(memcmp(strTemp2,"SET_COUNTING",strlen(strTemp2)) == 0){	// SKU Locking
					strcpy_s(count->pcSkun, sizeof(count->pcSkun),user->pcSkun);
					break;
				}
				if(memcmp(strTemp2,"RESET_COUNTING",strlen(strTemp2)) == 0){// SKU unlocking
					memset(count->pcSkun,0,sizeof(count->pcSkun));
					break;
				}
				if(memcmp(strTemp2,"SET_GSKU",strlen(strTemp2)) == 0){			// Gap Locking
					strcpy_s(gap->pcSkun, sizeof(gap->pcSkun), user->pcSkun);
					break;
				}
				if(memcmp(strTemp2,"RESET_GSKU",strlen(strTemp2)) == 0){		// Gap Unlocking
					memset(gap->pcSkun,0,sizeof(gap->pcSkun));
					break;
				}
				if(memcmp(strTemp2,"TOP_LINE",strlen(strTemp2)) == 0){
					user->iThisLine = user->iThisLine + atoi(strTemp3);
					break;
				}
				break;
			case 'Y':
			case 'y': /* Function Key setup function */
				sscanf_s(pcReadBuffer,"%s %s",strTemp1,sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				if(memcmp(strTemp2,"SPECIAL",strlen(strTemp2)) == 0) {
					sprintf_s(strTemp1, sizeof(strTemp1),"%cKE%c",27,strTemp2[0]);
					strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
					break;
				}
				sprintf_s(strTemp1, sizeof(strTemp1),"%cKE%c",27,strTemp2[0]);
				strcat_s(pcBuffer, sizeof(pcBuffer),strTemp1);
				break;
			case 'Z':
			case 'z': /* Special Reason Selection */
				sscanf_s(pcReadBuffer, "%s %s", strTemp1, sizeof(strTemp1), strTemp2, sizeof(strTemp2));
				strncpy_s(user->pcOption, sizeof(user->pcOption),user->pcLastInput,sizeof(user->pcOption));
				if(memcmp(strTemp2,"MDN",strlen(strTemp2)) == 0) {
					if(atoi(user->pcOption) < 1 || atoi(user->pcOption) > (user->iReasonLine - 1)) {
						strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
						break;
					}
					memset(user->pcSelReas,0,sizeof(user->pcSelReas));
					memset(user->pcSelDesc,0,sizeof(user->pcSelDesc));
					user->pcSelImdn=FALSE;
					user->pcSelIwtf=FALSE;
				  strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
					switch(user->pcOption[0]) {
						case '1': /* Option 1 */
							strncpy_s(user->pcSelReas, sizeof(user->pcSelReas), user->pcReas1,sizeof(user->pcReas1)-1);
							strncpy_s(user->pcSelDesc, sizeof(user->pcSelDesc), user->pcSel1+2,sizeof(user->pcSel1)-2);
							user->pcSelImdn=user->pcImdn1;
							user->pcSelIwtf=user->pcIwtf1;
							if ((user->pcSelImdn) && (user->pcSelIwtf))
								    strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
							break;
						case '2': /* Option 2 */
							strncpy_s(user->pcSelReas, sizeof(user->pcSelReas), user->pcReas2,sizeof(user->pcReas2)-1);
							strncpy_s(user->pcSelDesc, sizeof(user->pcSelDesc), user->pcSel2+2,sizeof(user->pcSel2)-2);
							user->pcSelImdn=user->pcImdn2;
							user->pcSelIwtf=user->pcIwtf2;
							if ((user->pcSelImdn) && (user->pcSelIwtf))
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
							break;
						case '3': /* Option 3 */
							strncpy_s(user->pcSelReas, sizeof(user->pcSelReas), user->pcReas3,sizeof(user->pcReas3)-1);
							strncpy_s(user->pcSelDesc, sizeof(user->pcSelDesc), user->pcSel3+2,sizeof(user->pcSel3)-2);
							user->pcSelImdn=user->pcImdn3;
							user->pcSelIwtf=user->pcIwtf3;
							if ((user->pcSelImdn) && (user->pcSelIwtf))
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
						break;
							case '4': /* Option 4 */
							strncpy_s(user->pcSelReas, sizeof(user->pcSelReas), user->pcReas4,sizeof(user->pcReas4)-1);
							strncpy_s(user->pcSelDesc, sizeof(user->pcSelDesc), user->pcSel4+2,sizeof(user->pcSel4)-2);
							user->pcSelImdn=user->pcImdn4;
							user->pcSelIwtf=user->pcIwtf4;
							if ((user->pcSelImdn) && (user->pcSelIwtf))
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
							break;
						case '5': /* Option 5 */
							strncpy_s(user->pcSelReas, sizeof(user->pcSelReas), user->pcReas5,sizeof(user->pcReas5)-1);
							strncpy_s(user->pcSelDesc, sizeof(user->pcSelDesc), user->pcSel5+2,sizeof(user->pcSel5)-2);
							user->pcSelImdn=user->pcImdn5;
							user->pcSelIwtf=user->pcIwtf5;
							if ((user->pcSelImdn) && (user->pcSelIwtf))
								strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "1");
							break;
						break;
					}
				}
				if (memcmp(strTemp2,"SEL",strlen(strTemp2)) == 0) {
					if (atoi(user->pcLastInput) < 1 || atoi(user->pcLastInput) > 2) {
					  strcpy_s(user->pcLastInput, sizeof(user->pcLastInput), "0");
						break;
					}
					switch(user->pcLastInput[0]) {
						case '1': /* Mark-Down Option 1 */
							user->pcSaImdn=TRUE;
							user->pcSaIwtf=FALSE;
						break;
						case '2': /* Write Off Option 2 */
							user->pcSaImdn=FALSE;
							user->pcSaIwtf=TRUE;
						break;
					break;
					}
				break;
		    }
			default:
				break;
		}
	}

	iLength = strlen(pcBuffer);
	iReturn = send(sSocket, pcBuffer, iLength, 0);
	fprintf(ProcessLogHandle(),"OUT>(%d):%s\n", iLength,pcBuffer);
	ProcessLogFlushBuffer();

	if(iReturn < 0)
	{
		vCloseSocket("Close socket, send failed",sSocket,iReturn);
		user->fLoggedOn = FALSE;
		return(0); /* send unsuccessful - stop */
	}
	lNewPos = ftell(hCommandFile);
	if(user->fLoggedOn == FALSE) {
		lNewPos = 0;
	}
	return(lNewPos);
}

/***************************************************************************
Function:	 Logon Attempt
Description: This function is called when a User logs on.
Passed:		 Socket number
Return:		 TRUE = logged on.
****************************************************************************/
BOOL fLogonAttempt(SOCKET sSocket)
{
	int iReturn;
	int iLength;

	iLength = recv(sSocket, pcBuffer, sizeof(pcBuffer), 0);

	/* if the MU gracefully shuts down, rc will be zero on the above recv() */
	if(iLength<=0) {/* DGC changed */
		/* Added function to Clear Saved user connection */
		vClearSvUser(sSocket);
		vCloseSocket("Close socket, logon failed", sSocket, iLength);
		return(FALSE); /* logon unsuccessful */
	}
	pcBuffer[iLength] = 0;
	if(pcBuffer[1] != 'L') { //Logon not received
		return(FALSE);
	}
	/* reply with a clear screen and function key enable */
	sprintf_s(pcBuffer, sizeof(pcBuffer),"%cC00",27);
	iLength = strlen(pcBuffer);
	/*printf ("Send '%0.71s'\n", pcBuffer);  */
	iReturn = send(sSocket, pcBuffer, iLength, 0);
	if(iReturn < 0) {
	//fprintf(hLogFile,"send(%d,pcBuffer,%d,0) error %d\n", sSocket,iLength,iReturn);
	}
	return(TRUE);
}
/***************************************************************************
Function:	 Find Label
Description: This function finds a label in macro file
				 First it checks from the current position downwards
				 Then it checks from the top of file downwards
Passed:		 Label name in string
Return:		 1 = Found Label, 0 = Label not found.
****************************************************************************/
int iFindLabel(char *pcLabel)
{
	size_t iLength = strlen(pcLabel);
	char pcReadBuffer[129];
	/* Seek from current line in Macro file */
	while(feof(hCommandFile) == 0) {
		fgets(pcReadBuffer,128,hCommandFile);
		if(pcReadBuffer[0] == ':') {
			if(memcmp(pcLabel,&pcReadBuffer[1],iLength) == 0) {
				fprintf(ProcessLogHandle(),"\nJUMPed to %s\n",pcLabel);
				return(1); /* found it */
			}
		}
	}
	/* Else Seek from TOP line in Macro file */
	fseek(hCommandFile,0,SEEK_SET);
	while(feof(hCommandFile) == 0) {
		fgets(pcReadBuffer,128,hCommandFile);
		if(pcReadBuffer[0] == ':') {
			if(memcmp(pcLabel,&pcReadBuffer[1],iLength) == 0) {
				fprintf(ProcessLogHandle(),"\nJUMPed to %s\n",pcLabel);
				return(1); /* found it */
			}
		}
	}
	/* label not found */
	fprintf(ProcessLogHandle(),"\nJUMP *label not found* %s\n",pcLabel);
	return(0);
}
/***************************************************************************
Function:    Initialise Reason Descriptions
Description: Initialise Reason Description Workareas for display
Passed:      User Number
Return:      None
****************************************************************************/
void vInitReasonDescs(int sessionNumber)
{
	USER_TYPE *user = &sUser[sessionNumber];

	memset(user->pcSel1,0,sizeof(user->pcSel1));
	memset(user->pcSel2,0,sizeof(user->pcSel2));
	memset(user->pcSel3,0,sizeof(user->pcSel3));
	memset(user->pcSel4,0,sizeof(user->pcSel4));
	memset(user->pcSel5,0,sizeof(user->pcSel5));
}

/***************************************************************************
Function:	 Menu LogOut
Description: This function logs out the user if No Main Menu activity
Passed:		 Socket number, User Number
Return:		 Current Position
****************************************************************************/
long lMenuLogoff(SOCKET sSocket, int sessionNumber)
{
	USER_TYPE *user = &sUser[sessionNumber];

	int iReturn;
  size_t iLength;
	long lNewPos;
	/* Label of the Main Menu Close Routine in Command File*/
	char strTemp[] = "SIGN_OUT\0";
	strcpy_s(user->pcSystemOut, sizeof(user->pcSystemOut),"YES");
	if (iFindLabel(strTemp) == 0) {
	//	fprintf(hLogFile,"Error Finding Label %s\n",strTemp);
	}
	user->lTimeOut = 99999;
 	pcBuffer[0] = 0;
	/* Reply with a Null message */
  iLength = strlen(pcBuffer);
  iReturn = send(sSocket, pcBuffer, iLength, 0);
 	if(iReturn < 0)	{
 		vCloseSocket("Close socket, send failed",sSocket,iReturn);
 		user->fLoggedOn = FALSE;
 		return(0); /* send unsuccessful - stop */
 	}
	lNewPos = ftell(hCommandFile);
	return(lNewPos);
}
